#!/usr/bin/perl

#
#  fetch.cgi
#  gets weatherdata from Wunderground
#
#  Part of Loxone Weather for Loxberry
#
#  Latest change: 16/05/16 10:02:00 Mo
#
#  (C) 2016 by Michael Schlenstedt
#

# Version of this script
my $version = "2.0.0";

# Read settings
require "./data/settings.dat";

# Check for parameters we got from URL
foreach (split(/&/,$ENV{'QUERY_STRING'})){
  ($namef,$value) = split(/=/,$_,2);
  $namef =~ tr/+/ /;
  $namef =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  if($query{$namef}){
    $query{$namef} .= ",$value";
    $Multiple{$namef} = 1;
  }else{
    $query{$namef} = $value;
  }
}
foreach $var ("password") {
  if ($query{$var}) {
    ${$var} = $query{$var};
  }
}

# HTML output
print "Content-type: text/ascii\n\n";

# Check for password
if ($password ne $webpass) {
  print "Password not correct. Go away!";
  exit;
}

# Trigger fetching of data
# Without the following workaround
# the script cannot be executed as
# background process via CGI
my $pid = fork();
die "Fork failed: $!" if !defined $pid;
if ($pid == 0) {
# do this in the child
 open STDIN, "</dev/null";
 open STDOUT, ">/dev/null";
 open STDERR, ">/dev/null";
 system('cd ./bin && ./fetch.pl &');
}

# Print OK and exit
print "fetch\@1\n";

# End
exit;
